/**
 * This file was auto-generated by openapi-typescript.
 * Do not make direct changes to the file.
 */


export interface paths {
  "/api/user/register": {
    /** Get user using its ip address or create a new user */
    get: operations["register_new_user_api_user_register_get"];
  };
  "/api/languages": {
    /** Get all supported languages */
    get: operations["get_languages_api_languages_get"];
  };
  "/api/file/new": {
    /** Create new file */
    post: operations["new_file_api_file_new_post"];
  };
  "/api/file/{file_uid}": {
    /** Get file by its uid */
    get: operations["get_file_api_file__file_uid__get"];
  };
  "/api/file/{file_uid}/mark": {
    /** Change user's mark for this file */
    put: operations["update_file_mark_api_file__file_uid__mark_put"];
  };
  "/api/top": {
    /** Get top files by stars */
    get: operations["get_file_top_api_top_get"];
  };
  "/healthy": {
    /** Healthy */
    get: operations["healthy_healthy_get"];
  };
}

export type webhooks = Record<string, never>;

export interface components {
  schemas: {
    /** FileInResponse */
    FileInResponse: {
      /** Uid */
      uid: string;
      /** Title */
      title: string;
      /** Content */
      content: string;
      language: components["schemas"]["Language"];
      visibility: components["schemas"]["FileVisibility"];
      mark: components["schemas"]["FileMark"];
      /** Star Count */
      star_count: number;
    };
    /**
     * FileMark 
     * @description An enumeration. 
     * @enum {unknown}
     */
    FileMark: "no_star" | "star";
    /**
     * FileVisibility 
     * @description An enumeration. 
     * @enum {unknown}
     */
    FileVisibility: "private" | "public";
    /** HTTPValidationError */
    HTTPValidationError: {
      /** Detail */
      detail?: (components["schemas"]["ValidationError"])[];
    };
    /** Language */
    Language: {
      /** Id */
      id: number;
      /** Name */
      name: string;
    };
    /** NewFileCreatedResponse */
    NewFileCreatedResponse: {
      /** Uid */
      uid: string;
    };
    /** NewFileInRequest */
    NewFileInRequest: {
      /** Title */
      title: string;
      /** Content */
      content: string;
      /** Language Id */
      language_id: number;
      visibility: components["schemas"]["FileVisibility"];
    };
    /** NewMarkRequest */
    NewMarkRequest: {
      /** File Uid */
      file_uid: string;
      new_mark: components["schemas"]["FileMark"];
    };
    /** UserTokenInResponse */
    UserTokenInResponse: {
      /** Access Token */
      access_token: string;
      /** Token Type */
      token_type: string;
    };
    /** ValidationError */
    ValidationError: {
      /** Location */
      loc: (string | number)[];
      /** Message */
      msg: string;
      /** Error Type */
      type: string;
    };
  };
  responses: never;
  parameters: never;
  requestBodies: never;
  headers: never;
  pathItems: never;
}

export type external = Record<string, never>;

export interface operations {

  register_new_user_api_user_register_get: {
    /** Get user using its ip address or create a new user */
    parameters: {
      query: {
        captcha_token: string;
      };
    };
    responses: {
      /** @description Successful Response */
      200: {
        content: {
          "application/json": components["schemas"]["UserTokenInResponse"];
        };
      };
      /** @description Validation Error */
      422: {
        content: {
          "application/json": components["schemas"]["HTTPValidationError"];
        };
      };
    };
  };
  get_languages_api_languages_get: {
    /** Get all supported languages */
    responses: {
      /** @description Successful Response */
      200: {
        content: {
          "application/json": (components["schemas"]["Language"])[];
        };
      };
    };
  };
  new_file_api_file_new_post: {
    /** Create new file */
    requestBody: {
      content: {
        "application/json": components["schemas"]["NewFileInRequest"];
      };
    };
    responses: {
      /** @description Successful Response */
      200: {
        content: {
          "application/json": components["schemas"]["NewFileCreatedResponse"];
        };
      };
      /** @description Validation Error */
      422: {
        content: {
          "application/json": components["schemas"]["HTTPValidationError"];
        };
      };
    };
  };
  get_file_api_file__file_uid__get: {
    /** Get file by its uid */
    parameters: {
      path: {
        file_uid: string;
      };
    };
    responses: {
      /** @description Successful Response */
      200: {
        content: {
          "application/json": components["schemas"]["FileInResponse"];
        };
      };
      /** @description Validation Error */
      422: {
        content: {
          "application/json": components["schemas"]["HTTPValidationError"];
        };
      };
    };
  };
  update_file_mark_api_file__file_uid__mark_put: {
    /** Change user's mark for this file */
    requestBody: {
      content: {
        "application/json": components["schemas"]["NewMarkRequest"];
      };
    };
    responses: {
      /** @description Successful Response */
      200: {
        content: {
          "application/json": Record<string, never>;
        };
      };
      /** @description Validation Error */
      422: {
        content: {
          "application/json": components["schemas"]["HTTPValidationError"];
        };
      };
    };
  };
  get_file_top_api_top_get: {
    /** Get top files by stars */
    parameters: {
      query: {
        offset: number;
        limit: number;
      };
    };
    responses: {
      /** @description Successful Response */
      200: {
        content: {
          "application/json": (components["schemas"]["FileInResponse"])[];
        };
      };
      /** @description Validation Error */
      422: {
        content: {
          "application/json": components["schemas"]["HTTPValidationError"];
        };
      };
    };
  };
  healthy_healthy_get: {
    /** Healthy */
    responses: {
      /** @description Successful Response */
      200: {
        content: {
          "application/json": string;
        };
      };
    };
  };
}
